/* Copyright (c) 2012 Nathan Osman

   Permission is hereby granted, free of charge, to any person obtaining a copy
   of this software and associated documentation files (the "Software"), to
   deal in the Software without restriction, including without limitation the
   rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
   sell copies of the Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE. */

#ifndef CINBOXITEM_H
#define CINBOXITEM_H

// Qt includes
#include <QList>
#include <QObject>
#include <QSharedPointer>

// Represents an item in the user's inbox
class CInboxItem : public QObject
{
    Q_OBJECT

    Q_PROPERTY(QString title         READ title        WRITE setTitle)
    Q_PROPERTY(QString body          READ body         WRITE setBody)
    Q_PROPERTY(quint32 creation_date READ creationDate WRITE setCreationDate)
    Q_PROPERTY(bool    is_unread     READ isUnread     WRITE setIsUnread)
    Q_PROPERTY(QString link          READ link         WRITE setLink)

public:

    QString title() { return m_title; }
    void setTitle(QString title) { m_title = title; }

    QString body() { return m_body; }
    void setBody(QString body) { m_body = body; }

    quint32 creationDate() { return m_creation_date; }
    void setCreationDate(quint32 creation_date) { m_creation_date = creation_date; }

    bool isUnread() { return m_is_unread; }
    void setIsUnread(bool is_unread) { m_is_unread = is_unread; }

    QString link() { return m_link; }
    void setLink(QString link) { m_link = link; }

private:

    QString m_title;
    QString m_body;
    quint32 m_creation_date;
    bool    m_is_unread;
    QString m_link;

};

// Define a list of QInboxItems
typedef QList< QSharedPointer<CInboxItem> > CInboxItemList;

#endif // CINBOXITEM_H
